Subject: bug#63103: closed (Re: bug#63103: 30.0.50; nconc compiler optimization breaks user packages)

From: [email-masked] (GNU bug Tracking System)
Date: Thu, 27 Apr 2023 12:30:03 +0000

Your bug report

#63103: 30.0.50; nconc compiler optimization breaks user packages

which was filed against the emacs package, has been closed.

The explanation is attached below, along with your original report.
If you require more details, please reply to [email-masked].

-- 
63103: https://debbugs.gnu.org/cgi/bugreport.cgi?bug=63103
GNU Bug Tracking System
Contact [email-masked] with problems

Subject: Re: bug#63103: 30.0.50; nconc compiler optimization breaks user packages
From: Mattias Engdegård <[email-masked]>
To: Daniel Mendler <[email-masked]>
Cc: Philip Kaludercic <[email-masked]>, Stefan Monnier <[email-masked]>, [email-masked]
Date: Thu, 27 Apr 2023 14:28:58 +0200
List-Id: <debbugs-submit.debbugs.gnu.org>

27 apr. 2023 kl. 12.42 skrev Daniel Mendler <[email-masked]>:

> I think it is
> kind of nice that `nconc' can be used as a tool to turn a proper list
> into an improper list and vice versa.

It's a bit obscure, though --

  (setcdr (last X) nil)

is a lot clearer than

  (nconc X nil)

and when the latter is preferred for performance, a comment might be polite to the reader.

Anyway, a fix has been pushed to master, and the manual entry for `nconc` got an extra example.

Subject: 30.0.50; nconc compiler optimization breaks user packages
From: Maks <[email-masked]>
To: [email-masked]
Date: Thu, 27 Apr 2023 01:50:42 +0300
List-Id: <debbugs-submit.debbugs.gnu.org>

Hello,

I'm sorry if you received similar emails from me, there were problems
with sending.

Commit e6ca5834a6eab91023e9f968b65683d0a74db1e7 ('Improved nconc and append compiler optimisations') breaks
vertico.el package. After very long debugging time I figured out that this commit affects behavior of
`completion-hilit-commonality` function of minibuffer.el. I don't completely understand how it works buf try
do describe some details.

If I set breakpoint before breaking commit to 'vertico--affixate then I'll get next stacktrace
```
Debugger entered--entering a function:
* vertico--affixate((#("report-emacs-bug" 0 1 (face (completions-first-difference))) #("cd" 0 1 (face (completions-first-difference))) #("5x5" 0 1 (face (completions-first-difference))) #("arp" 0 1 (face (completions-first-difference))) #("dbx" 0 1 (face (completions-first-difference))) #("dig" 0 1 (face (completions-first-difference))) #("erc" 0 1 (face (completions-first-difference))) #("ert" 0 1 (face (completions-first-difference))) #("eww" 0 1 (face (completions-first-difference))) #("ftp" 0 1 (face (completions-first-difference)))))
  vertico--arrange-candidates()
  vertico--exhibit()
  ...
```
buf if I do the same after breaking commit I'll get stacktrace
```
Debugger entered--entering a function:
* vertico--affixate((#("report-emacs-bug" 0 1 (face (completions-first-difference))) #("cd" 0 1 (face (completions-first-difference))) #("5x5" 0 1 (face (completions-first-difference))) #("arp" 0 1 (face (completions-first-difference))) #("dbx" 0 1 (face (completions-first-difference))) #("dig" 0 1 (face (completions-first-difference))) #("erc" 0 1 (face (completions-first-difference))) #("ert" 0 1 (face (completions-first-difference))) #("eww" 0 1 (face (completions-first-difference))) #("ftp" 0 1 (face (completions-first-difference))) . 0))
  vertico--arrange-candidates()
  vertico--exhibit()
  ...
```

As you can see, the difference is in the tail of the list. With the such tail vertico.el package crashed with error:
```
Error in post-command-hook (vertico--exhibit): (wrong-type-argument listp 0)
```

But testing `completion-hilit-commonality` in REPL separetely from vertico.el package
give the same result (with 0 at the end of list).

Before sending this report I have tried a lot of versions of the
vertico.el package and have the same result. So I tend to think that problem is not directly
related to package.